/*
 * drv_timer.c
 *
 *  Created on: 2017/08/19
 *      Author: user
 */


#include "drv_timer.h"
void R_TAU0_Create(void)
{
    /* Stop all channels */
    TTH0 =_02_TAU_CH1_H8_STOP_TRG_ON;

    /* Channel 0 is used as master channel for PWM output function */
    TMR00L = _01_TAU_MODE_PWM_MASTER;
    /* Consecutive reading from the TDR0nH and TDR0nL registers and consecutive writing to the TDR0nH and TDR0nL
    registers must be performed in the state where an interrupt is disabled by the DI instruction. */
    TDR00H = _07_TAU_TDR00H_VALUE;
    TDR00L = _CF_TAU_TDR00L_VALUE;
    TO0 = 0x03;

    /* Channel 1 is used as slave channel for PWM output function */
    TMR01H = _00_TAU_CLOCK_SELECT_CKM0 | _00_TAU_CLOCK_MODE_CKS | _00_TAU_COMBINATION_SLAVE |
             _04_TAU_TRIGGER_MASTER_INT;
    TMR01L = _09_TAU_MODE_PWM_SLAVE;
    /* Consecutive reading from the TDR0nH and TDR0nL registers and consecutive writing to the TDR0nH and TDR0nL
    registers must be performed in the state where an interrupt is disabled by the DI instruction. */
//    TDR01H = _03_TAU_TDR01H_VALUE;
//    TDR01L = _E8_TAU_TDR01L_VALUE;
    TOM0 = 0x02;
}
/***********************************************************************************************************************
* Function Name: R_TAU0_Channel0_Start
* Description  : This function starts TAU0 channel 0 counter.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_TAU0_Channel0_Start(void)
{
    TOE0 = 0x02;
    TS0 = 0x03;
}
/***********************************************************************************************************************
* Function Name: R_TAU0_Channel0_Stop
* Description  : This function stops TAU0 channel 0 counter.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_TAU0_Channel0_Stop(void)
{
    TT0 = 0x03;
    TOE0 = 0x00;
}
