/*
 * drv_uart.c
 *
 *  Created on: 2017/08/18
 *      Author: user
 */
#include "drv_uart.h"

void R_SAU0_Create(void)
{
//    SPS0 = _00_SAU_CK00_FCLK_0 | _00_SAU_CK01_FCLK_0;
    ST0 = 0x03;    /* disable UART0 receive and transmit */
    SMR00L = _20_SAU_SMRMN_INITIALVALUE | _02_SAU_MODE_UART | _01_SAU_BUFFER_EMPTY;
    SMR00H = _80_SAU_CLOCK_SELECT_CK01 | _00_SAU_TRIGGER_SOFTWARE;
    SCR00L = _80_SAU_LSB | _10_SAU_STOP_1 | _07_SAU_LENGTH_8;
    SCR00H = _80_SAU_TRANSMISSION | _00_SAU_INTSRE_MASK | _00_SAU_PARITY_NONE;
    SDR00H = 0x26;
    NFEN0 = _01_SAU_RXD0_FILTER_ON;
    SIR01 = _04_SAU_SIRMN_FECTMN | _02_SAU_SIRMN_PECTMN | _01_SAU_SIRMN_OVCTMN;    /* clear error flag */
    SMR01L = _20_SAU_SMRMN_INITIALVALUE | _00_SAU_EDGE_FALL | _02_SAU_MODE_UART | _00_SAU_TRANSFER_END;
    SMR01H = _00_SAU_CLOCK_SELECT_CK00 | _01_SAU_TRIGGER_RXD;
    SCR01L = _80_SAU_LSB | _10_SAU_STOP_1 | _07_SAU_LENGTH_8;
    SCR01H = _40_SAU_RECEPTION | _04_SAU_INTSRE_ENABLE | _00_SAU_PARITY_NONE;
    SDR01H = 0x26;
    SO0 = _01_SAU_CH0_DATA_OUTPUT_1;
//    SOL0 |= _00_SAU_CHANNEL0_NORMAL;    /* output level normal */
    SOE0 = _01_SAU_CH0_OUTPUT_ENABLE;    /* enable UART0 output */

    SS0 = 0x03;    /* enable UART0 receive and transmit */
}


void drv_uartSend(unsigned char cmd,unsigned short data)
{
    TXD0 = cmd;
    while((SSR00 & (0x40)));
    TXD0 = (unsigned char)(data & 0x00FF);
    while((SSR00 & (0x40)));
    TXD0 = (unsigned char)((data & 0xFF00)>>8);
    while((SSR00 & (0x40)));

}

void drv_uartReceive(unsigned char *data)
{
    while((SSR01 & (0x20)) != 0x20);
   	*data = RXD0;
}

void uartCMD_Receive(UART_CMD *data)
{
    drv_uartReceive(&data[0].uartCMD);
    drv_uartReceive(&data[0].uartData[0]);
    drv_uartReceive(&data[0].uartData[1]);
}

void INT_ST0 (void)
{
}
//void INT_CSI00 (void) { }
//void INT_IIC00 (void) { }

/*
 * INT_SR0 (0xC)
 */
void INT_SR0 (void) { }

/*
 * INT_SRE0 (0xE)
 */
void INT_SRE0 (void) { }
